/***********************************************************************************************************************
 *
 * blueBill Core - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it
 * SCM: https://kenai.com/hg/bluebill~core-src
 *
 **********************************************************************************************************************/
package it.tidalwave.semantic.document;

import javax.annotation.Nonnull;
import java.util.Collection;
import java.io.IOException;

/***********************************************************************************************************************
 *
 * The role of being able to be sent somewhere.
 * 
 * @stereotype Role
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public interface Sendable 
  {
    public static final Class<Sendable> Sendable = Sendable.class;
    
    /*******************************************************************************************************************
     *
     * Send the object to the given recipients. This method supports passing a "sending context", that could be e.g.
     * a reference to a user interface to open a popup, etc...
     * 
     * @param sendingContext  the context
     * @param recipients      the recipients
     *
     ******************************************************************************************************************/
    public void sendTo (@Nonnull Object sendingContext, @Nonnull Collection<String> recipients)
      throws IOException;  
  }
